// D import file generated from 'derelict/ode/types.d'
module derelict.ode.types;
private 
{
	import std.math;
	import core.vararg;
	import core.stdc.config;
	import core.stdc.time;
	import derelict.util.system;
}
alias long dint64;
alias ulong duint64;
alias int dint32;
alias uint duint32;
alias short dint16;
alias ushort duint16;
alias byte dint8;
alias ubyte duint8;
version (DerelictODE_Single)
{
	enum dDOUBLE = false;
	enum dSINGLE = true;
}
else
{
	enum dDOUBLE = true;
	enum dSINGLE = false;
}
static if (dSINGLE)
{
	enum dInfinity = (float).infinity;
}
else
{
	enum dInfinity = (double).infinity;
}
alias PI M_PI;
alias PI_2 M_PI_2;
alias SQRT1_2 M_SQRT1_2;
static if (dSINGLE)
{
	alias float dReal;
}
else
{
	alias double dReal;
}
version (DerelictOde_TriMesh_16Bit_Indices)
{
	version (DerelictOde_TriMesh_GIMPACT)
	{
		alias duint32 dTriIndex;
	}
	else
	{
		alias duint16 dTriIndex;
	}
}
else
{
	alias duint32 dTriIndex;
}
int dPAD(int a);
alias dReal[4] dVector3;
alias dReal[4] dVector4;
alias dReal[4 * 3] dMatrix3;
alias dReal[4 * 4] dMatrix4;
alias dReal[8 * 6] dMatrix6;
alias dReal[4] dQuaternion;
dReal dRecip(dReal x);
dReal dRecipSqrt(dReal x);
dReal dFMod(dReal a, dReal b);
alias sqrt dSqrt;
alias sin dSin;
alias cos dCos;
alias fabs dFabs;
alias atan2 dAtan2;
alias acos dAcos;
alias fmod dFMod;
alias floor dFloor;
alias ceil dCeil;
alias copysign dCopySign;
alias nextafter dNextAfter;
alias isnan dIsNan;
struct dxWorld;
struct dxSpace;
struct dxBody;
struct dxGeom;
struct dxJoint;
struct dxJointNode;
struct dxJointGroup;
struct dxWorldProcessThreadingManager;
alias dxWorld* dWorldID;
alias dxSpace* dSpaceID;
alias dxBody* dBodyID;
alias dxGeom* dGeomID;
alias dxJoint* dJointID;
alias dxJointGroup* dJointGroupID;
alias dxWorldProcessThreadingManager* dWorldStepThreadingManagerId;
enum 
{
	d_ERR_UNKNOWN = 0,
	d_ERR_IASSERT,
	d_ERR_UASSERT,
	d_ERR_LCP,
}
alias int dJointType;
enum 
{
	dJointTypeNone = 0,
	dJointTypeBall,
	dJointTypeHinge,
	dJointTypeSlider,
	dJointTypeContact,
	dJointTypeUniversal,
	dJointTypeHinge2,
	dJointTypeFixed,
	dJointTypeNull,
	dJointTypeAMotor,
	dJointTypeLMotor,
	dJointTypePlane2D,
	dJointTypePR,
	dJointTypePU,
	dJointTypePiston,
	dJointTypeDBall,
	dJointTypeDHinge,
	dJointTypeTransmission,
}
enum 
{
	dParamLoStop = 0,
	dParamHiStop,
	dParamVel,
	dParamFMax,
	dParamFudgeFactor,
	dParamBounce,
	dParamCFM,
	dParamStopERP,
	dParamStopCFM,
	dParamSuspensionERP,
	dParamSuspensionCFM,
	dParamERP,
	dParamsInGroup,
	dParamLoStop1 = 0,
	dParamHiStop1,
	dParamVel1,
	dParamFMax1,
	dParamFudgeFactor1,
	dParamBounce1,
	dParamCFM1,
	dParamStopERP1,
	dParamStopCFM1,
	dParamSuspensionERP1,
	dParamSuspensionCFM1,
	dParamERP1,
	dParamLoStop2 = 256,
	dParamHiStop2,
	dParamVel2,
	dParamFMax2,
	dParamFudgeFactor2,
	dParamBounce2,
	dParamCFM2,
	dParamStopERP2,
	dParamStopCFM2,
	dParamSuspensionERP2,
	dParamSuspensionCFM2,
	dParamERP2,
	dParamLoStop3 = 512,
	dParamHiStop3,
	dParamVel3,
	dParamFMax3,
	dParamFudgeFactor3,
	dParamBounce3,
	dParamCFM3,
	dParamStopERP3,
	dParamStopCFM3,
	dParamSuspensionERP3,
	dParamSuspensionCFM3,
	dParamERP3,
	dParamGroup = 256,
}
enum 
{
	dAMotorUser = 0,
	dAMotorEuler = 1,
}
enum 
{
	dTransmissionParallelAxes = 0,
	dTransmissionIntersectingAxes = 1,
	dTransmissionChainDrive = 2,
}
struct dJointFeedback
{
	dVector3 f1;
	dVector3 t1;
	dVector3 f2;
	dVector3 t2;
}
enum 
{
	dGeomCommonControlClass = 0,
	dGeomColliderControlClass = 1,
}
enum 
{
	dGeomCommonAnyControlCode = 0,
	dGeomColliderSetMergeSphereContactsControlCode = 1,
	dGeomColliderGetMergeSphereContactsControlCode = 2,
}
enum 
{
	dGeomColliderMergeContactsValue__Default = 0,
	dGeomColliderMergeContactsValue_None = 1,
	dGeomColliderMergeContactsValue_Normals = 2,
	dGeomColliderMergeContactsValue_Full = 3,
}
enum 
{
	CONTACTS_UNIMPORTANT = 2147483648u,
}
enum 
{
	dMaxUserClasses = 4,
}
enum 
{
	dSphereClass = 0,
	dBoxClass,
	dCapsuleClass,
	dCylinderClass,
	dPlaneClass,
	dRayClass,
	dConvexClass,
	dGeomTransformClass,
	dTriMeshClass,
	dHeightFieldClass,
	dFirstSpaceClass,
	dSimpleSpaceClass = dFirstSpaceClass,
	dHashSpaceClass,
	dSweepAndPruneSpaceClass,
	dQuadTreeClass,
	dLastSpaceClass = dQuadTreeClass,
	dFirstUserClass,
	dLastUserClass = dFirstUserClass + dMaxUserClasses - 1,
	dGeomNumClasses,
}
alias dCapsuleClass dCCylinderClass;
struct dxHeightfieldData;
alias dxHeightfieldData* dHeightfieldDataID;
extern (C) nothrow 
{
	alias dReal function(void*, int, int) dHeightfieldGetHeight;
	alias void function(dGeomID, ref dReal[6]) dGetAABBFn;
	alias int function(dGeomID, dGeomID, int, dContactGeom*, int) dColliderFn;
	alias dColliderFn function(int) dGetColliderFnFn;
	alias void function(dGeomID) dGeomDtorFn;
	alias int function(dGeomID, dGeomID, ref dReal[6]) dAABBTestFn;
}

struct dGeomClass
{
	int bytes;
	dGetColliderFnFn collider;
	dGetAABBFn aabb;
	dAABBTestFn aabb_test;
	dGeomDtorFn dtor;
}
extern (C) nothrow @nogc alias void function(void*, dGeomID, dGeomID) dNearCallback;


enum 
{
	dSAP_AXES_XYZ = 0 | 1 << 2 | 2 << 4,
	dSAP_AXES_XZY = 0 | 2 << 2 | 1 << 4,
	dSAP_AXES_YXZ = 1 | 0 << 2 | 2 << 4,
	dSAP_AXES_YZX = 1 | 2 << 2 | 0 << 4,
	dSAP_AXES_ZXY = 2 | 0 << 2 | 1 << 4,
	dSAP_AXES_ZYX = 2 | 1 << 2 | 0 << 4,
}
struct dxTriMeshData;
alias dxTriMeshData* dTriMeshDataID;
enum 
{
	TRIMESH_FACE_NORMALS,
}
extern (C) nothrow @nogc 
{
	alias int function(dGeomID, dGeomID, int) dTriCallback;
	alias void function(dGeomID, dGeomID, const(int)*, int) dTriArrayCallback;
	alias int function(dGeomID, dGeomID, int, dReal, dReal) dTriRayCallback;
	alias int function(dGeomID, int, int) dTriTriMergeCallback;
}

enum 
{
	dContactMu2 = 1,
	dContactFDir1 = 2,
	dContactBounce = 4,
	dContactSoftERP = 8,
	dContactSoftCFM = 16,
	dContactMotion1 = 32,
	dContactMotion2 = 64,
	dContactMotionN = 128,
	dContactSlip1 = 256,
	dContactSlip2 = 512,
	dContactRolling = 1024,
	dContactApprox0 = 0,
	dContactApprox1_1 = 4096,
	dContactApprox1_2 = 8192,
	dContactApprox1_N = 16384,
	dContactApprox1 = 28672,
}
struct dSurfaceParameters
{
	int mode;
	dReal mu;
	dReal mu2;
	dReal rho;
	dReal rho2;
	dReal rhoN;
	dReal bounce;
	dReal bounce_vel;
	dReal soft_erp;
	dReal soft_cfm;
	dReal motion1;
	dReal motion2;
	dReal motionN;
	dReal slip1;
	dReal slip2;
}
struct dContactGeom
{
	dVector3 pos;
	dVector3 normal;
	dReal depth;
	dGeomID g1;
	dGeomID g2;
	int side1;
	int side2;
}
struct dContact
{
	dSurfaceParameters surface;
	dContactGeom geom;
	dVector3 fdir1;
}
extern (C) nothrow alias void function(int, const(char)*, va_list ap) dMessageFunction;


struct dMass
{
	dReal mass;
	dVector3 c;
	dMatrix3 I;
}
extern (C) nothrow 
{
	alias void* function(size_t) dAllocFunction;
	alias void* function(void*, size_t, size_t) dReallocFunction;
	alias void function(void*, size_t) dFreeFunction;
}

enum dWORLDSTEP_THREADCOUNT_UNLIMITED = 0u;
enum dWORLDSTEP_RESERVEFACTOR_DEFAULT = 1.2F;
enum dWORLDSTEP_RESERVESIZE_DEFAULT = 65536u;
struct dWorldStepReserveInfo
{
	uint struct_size;
	float reserve_factor;
	uint reserve_minimum;
}
struct dWorldStepMemoryFunctionsInfo
{
	uint struct_size;
	extern (C) nothrow 
	{
		void* function(size_t) alloc_block;
		void* function(void*, size_t, size_t) shrink_block;
		void function(void*, size_t) free_block;
	}

}
enum : uint
{
	dInitFlagManualThreadCleanup = 1,
}
enum : uint
{
	dAllocateFlagsBasicData = 0,
	dAllocateFlagsCollisionData = 1,
	dAllocateMaskAll = ~0u,
}
auto dACCESS33(T)(T a, size_t i, size_t j)
{
	return a[i * 4 + j];
}
bool dVALIDVEC3(T)(T v)
{
	return !(dIsNan(v[0]) || dIsNan(v[1]) || dIsNan(v[2]));
}
bool dVALIDVEC4(T)(T v)
{
	return !(dIsNan(v[0]) || dIsNan(v[1]) || dIsNan(v[2]) || dIsNan(v[3]));
}
bool dVALIDMAT3(T)(T m)
{
	return !(dIsNan(m[0]) || dIsNan(m[1]) || dIsNan(m[2]) || dIsNan(m[3]) || dIsNan(m[4]) || dIsNan(m[5]) || dIsNan(m[6]) || dIsNan(m[7]) || dIsNan(m[8]) || dIsNan(m[9]) || dIsNan(m[10]) || dIsNan(m[11]));
}
bool dVALIDMAT4(T)(T m)
{
	return !(dIsNan(m[0]) || dIsNan(m[1]) || dIsNan(m[2]) || dIsNan(m[3]) || dIsNan(m[4]) || dIsNan(m[5]) || dIsNan(m[6]) || dIsNan(m[7]) || dIsNan(m[8]) || dIsNan(m[9]) || dIsNan(m[10]) || dIsNan(m[11]) || dIsNan(m[12]) || dIsNan(m[13]) || dIsNan(m[14]) || dIsNan(m[15]));
}
void dAddVectors3(dReal* res, const(dReal)* a, const(dReal)* b);
void dSubtractVectors3(dReal* res, const(dReal)* a, const(dReal)* b);
void dAddScaledVectors3(dReal* res, const(dReal)* a, const(dReal)* b, dReal a_scale, dReal b_scale);
void dScaleVector3(dReal* res, dReal nScale);
void dNegateVector3(dReal* res);
void dCopyVector3(dReal* res, const(dReal)* a);
void dCopyScaledVector3(dReal* res, const(dReal)* a, dReal nScale);
void dCopyNegatedVector3(dReal* res, const(dReal)* a);
void dCopyVector4(dReal* res, const(dReal)* a);
void dCopyMatrix4x4(dReal* res, const(dReal)* a);
void dCopyMatrix4x3(dReal* res, const(dReal)* a);
void dGetMatrixColumn3(dReal* res, const(dReal)* a, uint n);
dReal dCalcVectorLength3(const(dReal)* a);
dReal dCalcVectorLengthSquare3(const(dReal)* a);
dReal dCalcPointDepth3(const(dReal)* test_p, const(dReal)* plane_p, const(dReal)* plane_n);
dReal _dCalcVectorDot3(const(dReal)* a, const(dReal)* b, uint step_a, uint step_b);
dReal dCalcVectorDot3(const(dReal)* a, const(dReal)* b);
dReal dCalcVectorDot3_13(const(dReal)* a, const(dReal)* b);
dReal dCalcVectorDot3_31(const(dReal)* a, const(dReal)* b);
dReal dCalcVectorDot3_33(const(dReal)* a, const(dReal)* b);
dReal dCalcVectorDot3_14(const(dReal)* a, const(dReal)* b);
dReal dCalcVectorDot3_41(const(dReal)* a, const(dReal)* b);
dReal dCalcVectorDot3_44(const(dReal)* a, const(dReal)* b);
void _dCalcVectorCross3(dReal* res, const(dReal)* a, const(dReal)* b, uint step_res, uint step_a, uint step_b);
void dCalcVectorCross3(dReal* res, const(dReal)* a, const(dReal)* b);
void dCalcVectorCross3_114(dReal* res, const(dReal)* a, const(dReal)* b);
void dCalcVectorCross3_141(dReal* res, const(dReal)* a, const(dReal)* b);
void dCalcVectorCross3_144(dReal* res, const(dReal)* a, const(dReal)* b);
void dCalcVectorCross3_411(dReal* res, const(dReal)* a, const(dReal)* b);
void dCalcVectorCross3_414(dReal* res, const(dReal)* a, const(dReal)* b);
void dCalcVectorCross3_441(dReal* res, const(dReal)* a, const(dReal)* b);
void dCalcVectorCross3_444(dReal* res, const(dReal)* a, const(dReal)* b);
void dAddVectorCross3(dReal* res, const(dReal)* a, const(dReal)* b);
void dSubtractVectorCross3(dReal* res, const(dReal)* a, const(dReal)* b);
void dSetCrossMatrixPlus(dReal* res, const(dReal)* a, uint skip);
void dSetCrossMatrixMinus(dReal* res, const(dReal)* a, uint skip);
dReal dCalcPointsDistance3(const(dReal)* a, const(dReal)* b);
void dMultiplyHelper0_331(dReal* res, const(dReal)* a, const(dReal)* b);
void dMultiplyHelper1_331(dReal* res, const(dReal)* a, const(dReal)* b);
void dMultiplyHelper0_133(dReal* res, const(dReal)* a, const(dReal)* b);
void dMultiplyHelper1_133(dReal* res, const(dReal)* a, const(dReal)* b);
void dMultiply0_331(dReal* res, const(dReal)* a, const(dReal)* b);
void dMultiply1_331(dReal* res, const(dReal)* a, const(dReal)* b);
void dMultiply0_133(dReal* res, const(dReal)* a, const(dReal)* b);
void dMultiply0_333(dReal* res, const(dReal)* a, const(dReal)* b);
void dMultiply1_333(dReal* res, const(dReal)* a, const(dReal)* b);
void dMultiply2_333(dReal* res, const(dReal)* a, const(dReal)* b);
void dMultiplyAdd0_331(dReal* res, const(dReal)* a, const(dReal)* b);
void dMultiplyAdd1_331(dReal* res, const(dReal)* a, const(dReal)* b);
void dMultiplyAdd0_133(dReal* res, const(dReal)* a, const(dReal)* b);
void dMultiplyAdd0_333(dReal* res, const(dReal)* a, const(dReal)* b);
void dMultiplyAdd1_333(dReal* res, const(dReal)* a, const(dReal)* b);
void dMultiplyAdd2_333(dReal* res, const(dReal)* a, const(dReal)* b);
dReal dCalcMatrix3Det(const(dReal)* mat);
dReal dInvertMatrix3(dReal* dst, const(dReal)* ma);
struct dxThreadingImplementation;
alias dxThreadingImplementation* dThreadingImplementationID;
alias uint dmutexindex_t;
struct dxMutexGroup;
alias dxMutexGroup* dMutexGroupID;
extern (C) nothrow @nogc 
{
	alias dMutexGroupID function(dThreadingImplementationID, dmutexindex_t, const(char*)*) dMutexGroupAllocFunction;
	alias void function(dThreadingImplementationID, dMutexGroupID) dMutexGroupFreeFunction;
	alias void function(dThreadingImplementationID, dMutexGroupID, dmutexindex_t) dMutexGroupMutexLockFunction;
	alias void function(dThreadingImplementationID, dMutexGroupID, dmutexindex_t) dMutexGroupMutexUnlockFunction;
}

struct dxCallReleasee;
alias dxCallReleasee* dCallReleaseeID;
struct dxCallWait;
alias dxCallWait* dCallWaitID;
alias size_t ddependencycount_t;
alias ptrdiff_t ddependencychange_t;
alias size_t dcallindex_t;
struct dThreadedWaitTime
{
	time_t wait_sec;
	c_ulong wait_nsec;
}
extern (C) nothrow @nogc 
{
	alias int function(void*, dcallindex_t, dCallReleaseeID) dThreadedCallFunction;
	alias dCallWaitID function(dThreadingImplementationID) dThreadedCallWaitAllocFunction;
	alias void function(dThreadingImplementationID, dCallWaitID) dThreadedCallWaitResetFunction;
	alias void function(dThreadingImplementationID, dCallWaitID) dThreadedCallWaitFreeFunction;
	alias void function(dThreadingImplementationID, int*, dCallReleaseeID*, ddependencycount_t, dCallReleaseeID, dCallWaitID, dThreadedCallFunction*, void*, dcallindex_t, const(char)*) dThreadedCallPostFunction;
	alias void function(dThreadingImplementationID, dCallReleaseeID, ddependencychange_t) dThreadedCallDependenciesCountAlterFunction;
	alias void function(dThreadingImplementationID, int*, dCallWaitID, const(dThreadedWaitTime)*, const(char)*) dThreadedCallWaitFunction;
	alias uint function(dThreadingImplementationID) dThreadingImplThreadCountRetrieveFunction;
	alias int function(dThreadingImplementationID, ddependencycount_t) dThreadingImplResourcesForCallsPreallocateFunction;
}

struct dThreadingFunctionsInfo
{
	uint struct_size;
	dMutexGroupAllocFunction* alloc_mutex_group;
	dMutexGroupFreeFunction* free_mutex_group;
	dMutexGroupMutexLockFunction* lock_group_mutex;
	dMutexGroupMutexUnlockFunction* unlock_group_mutex;
	dThreadedCallWaitAllocFunction* alloc_call_wait;
	dThreadedCallWaitResetFunction* reset_call_wait;
	dThreadedCallWaitFreeFunction* free_call_wait;
	dThreadedCallPostFunction* post_call;
	dThreadedCallDependenciesCountAlterFunction* alter_call_dependencies_count;
	dThreadedCallWaitFunction* wait_call;
	dThreadingImplThreadCountRetrieveFunction* retrieve_thread_count;
	dThreadingImplResourcesForCallsPreallocateFunction* preallocate_resources_for_calls;
}
struct dStopwatch
{
	double time;
	c_ulong[2] cc;
}
enum dODE_VERSION = "0.13.1";
